/****************************************************************************
*  Program/file: AppDns.h
*  
*  Copyright (C) by RTX A/S, Denmark.
*  These computer program listings and specifications, are the property of 
*  RTX A/S, Denmark and shall not be reproduced or copied or used in 
*  whole or in part without written permission from RTX A/S, Denmark.
*
*  Programmer: LKA
*
*  MODULE:
*  CONTROLLING DOCUMENT:
*  SYSTEM DEPENDENCIES:
*   
*   
*  DESCRIPTION:
*   
*   
*   
*   
*   
****************************************************************************/

/****************************************************************************
*                                  PVCS info                                 
*****************************************************************************

$Author:   Jordi Casas  $
$Date:   28 Apr 2015 07:19:38  $
$Revision:   1.0  $
$Modtime:   28 Apr 2015 07:19:38  $
$Archive:   ./Projects/Amelie/COLApps/Apps/SmartCitizenRTX4100/rtx_AppDns.h  $

*/

/**
 @file rtx_AppDns.h
 @brief Very simple DNS Server (header)
 @author Jordi Casas
 @date 4/2015
*/

#ifndef RTXAPPDNS_H
#define RTXAPPDNS_H

/****************************************************************************
*                               Include files                                 
****************************************************************************/
//Type definitions

//Framework/Kernel

//Interfaces

//Configurations

//Private 

/****************************************************************************
*                              Macro definitions                             
****************************************************************************/


/****************************************************************************
*                     Enumerations/Type definitions/Structs                  
****************************************************************************/
/**
 * @brief Struct for store info (app:AppDns)
 **/
typedef struct 
{
  rsuint16  id;                /** identifier */
  rsuint16  flags;             /** flags*/
  rsuint16  qdcount;           /** question count */
  rsuint16  ancount;           /** answer record count */
  rsuint16  nscount;           /** authority record count */
  rsuint16  arcount;           /** additional record count */
  rsuint8   bodysection[200];  /** contain question or question & answer */
} DnsType;
/****************************************************************************
*                           Global variables/const                           
****************************************************************************/

//Header DNS
static const rschar dns_h_flags[] = {0x81,0x80};            /** Flags activate: Response & Recursive */
static const rschar dns_h_ancount[] = {0x00,0x01};          /** Force to 1 answer */
static const rschar dns_h_nscount[] = {0x00,0x00};          /** Force to 0 authority record */
static const rschar dns_h_arcount[] = {0x00,0x00};          /** Force to 0 additional record */


//Answer DNS
static const rschar dns_a_name[] = {0xc0,0x0c};             /** Name */
static const rschar dns_a_type[] = {0x00,0x01};             /** Type = A */
static const rschar dns_a_class[] = {0x00,0x01};            /** Class = IN */
static const rschar dns_a_ttl[] = {0x00,0x00,0x03,0x84};    /** TTL (900s=15min) */
static const rschar dns_a_sizeaddr[] = {0x00,0x04};         /** SizeAddr = 4 (ipv4 -> 32b -> 4B) */

/****************************************************************************
*                             Function prototypes                            
****************************************************************************/
PtEntryType* rtx_AppDnsServer(RsListEntryType *PtList);

#endif

